<?php

/**
 * inf_estado_contrato actions.
 *
 * @package    contratacion
 * @subpackage inf_estado_contrato
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_estado_contratoActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.no_contrato';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */



            /*
             * Variables opcionales
             */



            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            $whereArea = "";
            $whereContratista = "";
            $whereContrato = "";
            $whereSupervisor = "";
            $whereTipoContrato = "";
            $whereTipoConvenio = "";
            $whereEstadoLega = "";



            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_area=" . $request['id_area'];
            }

            if (isset($request['id_contratista'])) {
                $whereContratista = " AND tab0.id_contratista=" . $request['id_contratista'];
            }

            if (isset($request['no_contrato'])) {
                $whereContrato = " AND tab0.no_contrato=" . $request['no_contrato'];
            }

            if (isset($request['id_supervisor'])) {
                $whereSupervisor = " AND tab0.id_supervisor=" . $request['id_supervisor'];
            }

            if (isset($request['id_tipo_contrato'])) {
                $whereTipoContrato = " AND tab0.id_tipo_contrato=" . $request['id_tipo_contrato'];
            }

            if (isset($request['id_tipo_convenio'])) {
                $whereTipoConvenio = " AND tab0.id_tipo_convenio=" . $request['id_tipo_convenio'];
            }
            
            if (isset($request['estado_legaliza'])) {
                $whereEstadoLega = " AND tab0.estado_legaliza=" . $request['estado_legaliza'];
            }


            /*
             * 
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             * Se ajusto SQL ya que estaba mal escrito - 20230329::LAVILA
             */
            $sql = <<<EOD
select count(*) as count from (
                    
    select tab0.*

    from(                    
        select 
        tab0.*,
        tab3.FECHA_INICIO,
        tab3.FECHA_TERMINACION,
        tab2.area,tab2.id_area,tab2.id_abogado,tab2.abogado,
        case when tab3.id_contrato is null then 'PENDIENTE LEGALIZAR'
        WHEN tab3.id_contrato is not null and tab0.activo = 1 then 'PENDIENTE_CERRAR'
        else 'CERRADO'
        END as DESCRIPCION_LEGALIZA,
        case when tab3.id_contrato is null then 1
        WHEN tab3.id_contrato is not null and tab0.activo = 1 then 2
        else 3
        END as ESTADO_LEGALIZA,
        tab4.num_contrato as contrato_rvc
        from co_contrato_v tab0
        join co_seleccion_ep tab1 ON tab1.id_seleccion_ep = tab0.id_seleccion_ep
        join co_estudios_previos_v tab2 ON tab2.id_estudios_previos = tab1.id_estudios_previos
        --left join co_legaliza_contrato tab3 ON tab3.id_contrato = tab0.id_contrato
        left join (select id_contrato, max(fecha_terminacion) as fecha_terminacion, min(fecha_inicio) as fecha_inicio from co_legaliza_contrato group by id_contrato)tab3  ON tab3.id_contrato = tab0.id_contrato
        left join (select id_co_contrato, num_contrato from rvc_contrato group by id_co_contrato, num_contrato) tab4 on tab4.id_co_contrato = tab0.id_contrato
    )tab0

    where tab0.FECHA_CONTRATO between to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')

    $whereArea
    $whereContratista
    $whereContrato
    $whereSupervisor
    $whereTipoContrato
    $whereTipoConvenio
    $whereEstadoLega
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
                    
    select tab0.*

    from(                    
        select 
        tab0.*,
        tab3.FECHA_INICIO,
        tab3.FECHA_TERMINACION,
        tab2.area,tab2.id_area,tab2.id_abogado,tab2.abogado,
        case when tab3.id_contrato is null then 'PENDIENTE LEGALIZAR'
        WHEN tab3.id_contrato is not null and tab0.activo = 1 then 'PENDIENTE_CERRAR'
        else 'CERRADO'
        END as DESCRIPCION_LEGALIZA,
        case when tab3.id_contrato is null then 1
        WHEN tab3.id_contrato is not null and tab0.activo = 1 then 2
        else 3
        END as ESTADO_LEGALIZA,
        tab4.num_contrato as contrato_rvc
        from co_contrato_v tab0
        join co_seleccion_ep tab1 ON tab1.id_seleccion_ep = tab0.id_seleccion_ep
        join co_estudios_previos_v tab2 ON tab2.id_estudios_previos = tab1.id_estudios_previos
        --left join co_legaliza_contrato tab3 ON tab3.id_contrato = tab0.id_contrato
        left join (select id_contrato, max(fecha_terminacion) as fecha_terminacion, min(fecha_inicio) as fecha_inicio from co_legaliza_contrato group by id_contrato)tab3  ON tab3.id_contrato = tab0.id_contrato
        left join (select id_co_contrato, num_contrato from rvc_contrato group by id_co_contrato, num_contrato) tab4 on tab4.id_co_contrato = tab0.id_contrato
    )tab0

    where tab0.FECHA_CONTRATO between to_date('$fecha_ini','YYYY-MM-DD') AND  to_date('$fecha_fin','YYYY-MM-DD')

    $whereArea
    $whereContratista
    $whereContrato
    $whereSupervisor
    $whereTipoContrato
    $whereTipoConvenio
    $whereEstadoLega
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_gen_contrato] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
